#include <bits/stdc++.h>
using namespace std;

int n,k,in,idx,pot;
vector<int> v;
set<pair<int,int>> s;

int main()
{
    ios::sync_with_stdio(false);
    cin>>n>>k;
    int k1=k;
    for(int i=0;i<n;i++)
    {
        cin>>in;
        v.push_back(in);
    }
    for(int i=0;i<n;i++)
    {
        for(;idx<n && idx-i<=k;idx++)
        {
            s.insert({v[idx],idx});
        }
        while(s.begin()->second<i)
        {
            s.erase(s.begin());
        }
        cout<<s.begin()->first<<" ";
        k-=s.begin()->second-i;
        i=s.begin()->second;
        pot++;
        if(pot==n-k1)
        {
            return 0;
        }
    }
}